/*
  Tutanchamun, an arcade game
  Copyright (C) 1998  David Kastrup
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  */
#include "tutan.h"
#include "tutdisp.h"

int demcnt;
ubyte *dempnt;
int demflg;
  
int demowait()
{
  switch(d_joypause(5,0xc)) {
  case 4:
    return GAME;
  case 8:
    return QUIT;
  }
  return 0;
}

int demo()
{
  int i;
  static ubyte way[] = {
    28,8,
    20,1,
    8,4,
    4,2,
    8,4,
    6,2,
    2,0x80,
    8,4,
    28,1,
    8,8,
    20,2,
    20,1,
    2,4,
    12,8,
    8,4,
    4,0x80,
    8,1,
    8,2,
    8,8,
    12,1,
    22,4,
    3,1,
    1,0x80,
    4,1,
    31,8,
    4,2,
    1,0x80,
    5,1,
    2,4,
    2,0x80,
    8,1,
    4,8,
    8,1,
    8,2,
    8,4,
    1,0x40,
    7,4,
    8,2,
    4,4,
    4,8,
    8,1,
    8,4,
    12,1,
    28,8,
    7,0x80,
    6,4,
    6,0x84,
    20,1,
    8,0x80,
    20,8,
    0,4};

  demflg = 1;
  d_demomessage();
  for (;;) {
    clrscr();
    d_pict(d_pictur[3],18,4);
    d_wrbig("TUTANCHAMUN",2,18);
    d_write("COPYRIGHT 1989 BY",6,30);
    d_write("DAVID KASTRUP",10,34);
    d_write("LICENSED UNDER GPL",6,42);
    d_write("SEE DOCS FOR DETAILS",4,45);
    if ((i = demowait()) != 0) {
      demflg = 0;
      d_democlear();
      return i;
    }
    clrscr();
    d_wrbig("SCORES",12,0);
    d_rect(5,8,6,12,12);
    scrx = 0;
    d_wrbig("...20",20,6);
    draw(snamph.shaplf[0],8,6);
    d_wrbig("...40",20,10);
    draw(spimph.shaplf[0],8,10);
    draw(skumph.shaplf[0],12,10);
    draw(eggmph.shaplf[0],16,10);
    d_wrbig("...60",20,14);
    draw(batmph.shaplf[0],8,14);
    draw(whemph.shaplf[0],12,14);
    drawfull(scshd,8,20);
    drawfull(loshd,12,20);
    d_wrbig("..1000",16,20);
    drawfull(ubshd,8,26);
    drawfull(obshd,12,26);
    d_wrbig("..",16,26);
    d_write("MYSTERY",26,28);
    d_write("LEFT SECONDS..80",8,32);
    d_write("30000...   LIFE",14,38);
    d_write("EXTRA",36,36);
    d_write("EVERY 20000...   BOMB",2,44);
    d_write("SMART",36,42);
    drawfull(manshd,31,36);
    drawfull(lampshd,31,42);
    if ((i = demowait()) != 0) {
      demflg = 0;
      d_democlear();
      return i;
    }
    clrscr();
    shohig();
    demowait();
    clrscr();
    demcnt = 1;
    dempnt = way;
    switch ((i = demoplay())) {
    case QUIT:
    case GAME:
      demflg = 0;
      d_democlear();
      return i;
    }
  }
}


